#include "main.h"
#include <string.h>
#include "mcp41010.h"
#include "my_lcd.h"

//   
#define f_task_current 0x01
#define f_task_voltage 0x02

#int_AD
void  AD_isr(void) 
{
   // acp       
   // =1  ,  =0  
   //     , 
   
   // 
   testt=read_adc();
   if(acp==1)
      //{OS_Msg_Send_Now(smsg_current,izmer);}
      flag.sadc=1;  //
   else 
      //{OS_Msg_Send_Now(smsg_voltage,izmer);}
      flag.sadc=0;  //
      
   if(acp)
   {
      acp=0;
      set_adc_channel(0);
   }
   else
   {
      acp=1;
      set_adc_channel(1);
   }
   
}

#int_timer2
void Timer2_isr(void)  // 1 
{
  //    
  //      
  
  bounce++;
  if(bounce>150)
   bounce=0;
   //OS_Timer();
}

////////////////////////////////////////////////////////////////
//!void button()
//!{
//!   static short enable;
//!   //short static bouble_enable;
//!   
//!   disable_interrupts(INT_TIMER2);
//!   
//!   if(enable==0)
//!   {
//!      if(!(input(setup)))
//!      {
//!         enable_interrupts(INT_TIMER2);
//!         enable=1;
//!         ykaz_setup->open=0;
//!         bounce=0;
//!      }
//!      else
//!      {
//!         enable=0;
//!         ykaz_setup->open=1;
//!      }
//!   
//!      if(!(input(plus)))
//!      {
//!         enable_interrupts(INT_TIMER2);
//!         enable=1;
//!         ykaz_plus->open=0;
//!         bounce=0;
//!      }
//!      else
//!      {
//!         enable=0;
//!         ykaz_plus->open=1;
//!      }
//!   
//!      if(!(input(minus)))
//!      {
//!         enable_interrupts(INT_TIMER2);
//!         enable=1;
//!         ykaz_minus->open=0;
//!         bounce=0;
//!      }
//!      else
//!      {
//!         enable=0;
//!         ykaz_plus->open=1;
//!      }
//!   }
//!   else
//!   {
//!      if(!(input(setup))&&bounce>140)
//!      {
//!         disable_interrupts(INT_TIMER2);
//!         ykaz_setup->close=1;
//!         enable=0;
//!      }
//!      else if(input(setup)&&bounce>140)
//!      {
//!         disable_interrupts(INT_TIMER2);
//!         ykaz_setup->close=0;
//!         ykaz_setup->open=1;
//!         enable=0;
//!      }
//!      //------------------------------------------
//!      if(!(input(plus))&&bounce>140)
//!      {
//!         disable_interrupts(INT_TIMER2);
//!         ykaz_plus->close=1;
//!         enable=0;
//!      }
//!      else if(input(plus)&&bounce>140)
//!      {
//!         disable_interrupts(INT_TIMER2);
//!         ykaz_plus->close=0;
//!         ykaz_plus->open=1;
//!         enable=0;
//!      }
//!      //------------------------------------------
//!      if(!(input(minus))&&bounce>140)
//!      {
//!         disable_interrupts(INT_TIMER2);
//!         ykaz_minus->close=1;
//!         enable=0;
//!      }
//!      else if(input(minus)&&bounce>140)
//!      {
//!         disable_interrupts(INT_TIMER2);
//!         ykaz_minus->close=0;
//!         ykaz_minus->open=1;
//!         enable=0;
//!      }
//!   }
//!      
//!}

void Buttons (void)
{
    static  unsigned char s_ucPort;     //   
            unsigned char ucTemp;       

    ucTemp = 0x00;

    //if (!pin_BUTTON0) ucTemp |= 0x01;
    //if (!pin_BUTTON1) ucTemp |= 0x02;
   // if (!pin_BUTTON2) ucTemp |= 0x04;
    //if (!pin_BUTTON3) ucTemp |= 0x08;
    if (!(input(setup))) ucTemp |= 0x10;
    //if (!(input(digit))) ucTemp |= 0x20;
    if (!(input(plus))) ucTemp  |= 0x40;
    if (!(input(minus))) ucTemp |= 0x80;

    ucTemp      ^= s_ucPort;            //     
    s_ucPort    ^= ucTemp;              //   

    if (ucTemp)                         //  
    {
        m_Buttons.ucJitter = 0;
        return;
    }
    //------------------------------------------------------------------------------
    
    m_Buttons.ucJitter++;
    ucTemp = s_ucPort ^ m_Buttons.ucPressed;//   

    if (!m_Buttons.ucJitter && ucTemp)      //  ,  
    {
        //------------------------------------------------------------------------------
        //    
        //------------------------------------------------------------------------------
        
        if (m_Buttons.ucPressed & ucTemp)   //  
        {
            m_Buttons.ucJustReleased    |=  ucTemp;    //    
            m_Buttons.ucChanged         |=  ucTemp;    //   
            m_Buttons.ucShort           |=  ucTemp;    //    
            m_Buttons.ucShort           &= ~m_Buttons.ucHold;   //    
            m_Buttons.ucHold            &= ~ucTemp;
        }   // if released
        //------------------------------------------------------------------------------
        //    
        //------------------------------------------------------------------------------
        if ((m_Buttons.ucPressed ^ ucTemp) & ucTemp)    //  
        {
            m_Buttons.ucChanged         |=  ucTemp;  //   
            m_Buttons.ucJustPressed     |=  ucTemp;  //    
            m_Buttons.ucShort           &= ~ucTemp;
        }   // if pressed

        m_Buttons.ucPressed = s_ucPort;
        m_Buttons.ucCounter = 0;
    }   // if changed and debounced

    m_Buttons.ucCounter++;
    //------------------------------------------------------------------------------
    //    
    //------------------------------------------------------------------------------
    
    if (m_Buttons.ucCounter == 50)
    {
        m_Buttons.ucChanged |= m_Buttons.ucHold ^ m_Buttons.ucPressed;
        m_Buttons.ucHold = m_Buttons.ucPressed;
    }

}

void main()
{

   setup_adc_ports(sAN0|sAN1|VSS_VREF);
   setup_adc(ADC_CLOCK_INTERNAL|ADC_TAD_MUL_20);
   setup_spi(SPI_SS_DISABLED);
   setup_wdt(WDT_OFF);
   setup_timer_0(RTCC_INTERNAL|RTCC_DIV_256);
   setup_timer_1(T1_INTERNAL|T1_DIV_BY_8);     //   25 
   setup_timer_2(T2_DIV_BY_4,100,10);         //  1 ,  64 
   setup_timer_3(T3_DISABLED|T3_DIV_BY_1);
   setup_ccp1(CCP_OFF);
   setup_ccp2(CCP_COMPARE_RESET_TIMER);
   ccp_2=50000;    //      25 
   setup_comparator(NC_NC_NC_NC);// This device COMP currently not supported by the PICWizard
   
   enable_interrupts(INT_AD);
   enable_interrupts(INT_TIMER2);
   enable_interrupts(GLOBAL);
   //setup_oscillator(OSC_16MHZ|OSC_INTRC/*|OSC_PLL_ON*/);
   //setup_oscillator(OSC_16MHZ|OSC_NORMAL);

   
   set_tris_A(0xff);
   set_tris_B(0x00);
   set_tris_C(0xff);
   lcd_init();
   
   
   lcd_gotoxy(1,1);
   lcd_putc("U=");
   //while(1) restart_wdt();
   //       1
    st_status.temp_eeprom1=read_eeprom(1);
    st_status.temp_eeprom2=read_eeprom(2);
    st_status.ykaz_eeprom=&st_status.ystav;
    *st_status.ykaz_eeprom=st_status.temp_eeprom1;
    *(st_status.ykaz_eeprom+1)=st_status.temp_eeprom2;
    
    
    /////////////////////////////////////////////////////
while(1)
   {  
   restart_wdt();
   Buttons(); //    
   //izmer=read_adc();
   //    
   // 
   
   //--------------------------------------------------------------------------
   //     
   if(izmer>=st_status.ystav&&flag.sadc==1)
   { 
       
         //  
         //output_bit(yprav,0);
         //    
         lcd_putc("\fAmper\nMax");
       while(1)
       {
         restart_wdt();
         Buttons(); //    
         //  setup  ,  
         if(!(m_Buttons.ucPressed==m_setup))
         {
           restart_wdt();
           setup_fun();  //   
           reset_cpu();
         }
       }
   }
   else
   {
       //  
       //output_bit(yprav,1);
       //     
       //ykaz_indic->off=0;
   }
   //-------------------------------------------------------------------------
   //  setup  ,  
   if(m_Buttons.ucPressed==m_setup)
      setup_fun();
   //----------------------------------------------------------------------------
   //  32        
   if(ysred_flag==8)
   {
      restart_wdt();
      //         8
      //         
      if(flag.sadc==0)
         temp_volt=symma_volt>>3;   //  8
      else   
         temp_amper=symma_amper>>3; //  8
      //--------------------------------------------------------------------------
      // 
      if(flag.sadc==1)
      {
         temp_volt=(temp_volt<<2); //*4
         temp_volt*=10;
         bcd_volt(temp_volt);
   
         //  
         lcd_gotoxy(1,1);
         lcd_putc("U=");
         lcd_putc(tusahi+0x30);
         lcd_putc(sotni+0x30);
         lcd_putc(",");
         lcd_putc(dec+0x30);
         lcd_putc("B");
      }   
//!      //  
//!      ykaz_indic->bdc_i_ystav=ykaz_volt_amper->ystav_amper/9; // 200 * 
//!      ykaz_indic->bdc_i_ystav*=200; //
//!      bcd_amper(ykaz_indic->bdc_i_ystav);
//!   
//!      //   
//!      lcd_putc("  Iy=");
//!      lcd_putc(tusahi+0x30);
//!      lcd_putc(",");
//!      lcd_putc(sotni+0x30);
//!      lcd_putc("A");
      else
      {
         //  
         temp_amper=temp_amper<<2; //Iizm=(*4)/10
         temp_amper/=10; //   , 
         bcd_volt(temp_amper);
   
         //   
         lcd_putc("\nI=");
         lcd_putc(sotni+0x30);
         lcd_putc(",");
         lcd_putc(dec+0x30);
         //lcd_putc(edin+0x30);
         lcd_putc("A");
      }
         //     
      ysred_flag=0;
      symma_volt=0;
      symma_amper=0;
   }
   else
   {
      restart_wdt();
      ysred_flag++;
      if(flag.sadc==1)
         symma_volt+=izmer;
      else   
         symma_amper+=izmer;
   }
   }

}

void setup_fun()
{
   restart_wdt();
   //  
   //output_bit(yprav,0);
   //    
   while(m_Buttons.ucPressed==m_setup) 
   {  restart_wdt(); Buttons();}
   //    
   lcd_putc("\fSetup Iy\n");
   while(!ystav_flag)
   {
       Buttons();
       restart_wdt();
       lcd_gotoxy(1,2); //  
       lcd_putc("Iy=");
       
       //     setup_fun()
       if(m_Buttons.ucPressed==m_plus)
       {
         st_status.ystav+=25; // 25*4=100mv==0.1 A
         if(st_status.ystav>1000)
            st_status.ystav=0;
       }
       while(m_Buttons.ucPressed==m_plus) 
         {  restart_wdt(); Buttons();}
       
       if(m_Buttons.ucPressed==m_minus)
       {
         st_status.ystav-=25; // 25*4=100mv==0.1 A
         if(st_status.ystav>1000)
            st_status.ystav=0;
       }
       while(m_Buttons.ucPressed==m_minus) 
         {  restart_wdt(); Buttons();}
         //  
         st_status.ystav=st_status.ystav<<2; //Iyst=625-((Ived*20)/3)
         //ykaz_indic->bdc_i_ystav*=10; //
         bcd_volt(st_status.ystav);
   
         //   
         lcd_putc(tusahi+0x30);
         lcd_putc(",");
         lcd_putc(sotni+0x30);
         //lcd_putc(dec+0x30);
        // lcd_putc(" ");
         lcd_putc("A");
      //?     
      
      //    
      if(!(m_Buttons.ucPressed==m_setup))
         ystav_flag=1;    //    
   }
   //    
   while(m_Buttons.ucPressed==m_setup) 
   {  restart_wdt(); Buttons();}
   
//!   //
//!   for(i=0;i<8;i++)
//!   {
//!     *((unsigned long*)item1+1)<<=1;
//!     if(item1[3]&0x80) 
//!      item1[4]=item1[4]|1;
//!     *(unsigned long*)item1<<=1;
//!   }
   //   
   st_status.ykaz_eeprom=&st_status.ystav;
   st_status.temp_eeprom1=*st_status.ykaz_eeprom;
   st_status.temp_eeprom2=*(st_status.ykaz_eeprom+1);
   write_eeprom(1,st_status.temp_eeprom1);
   write_eeprom(2,st_status.temp_eeprom2);
   ystav_flag=0;
   restart_wdt();
   lcd_putc("\f");
}
